Foreman - Feature #12634

New HW Model flag pxe_loader in UI/API
11/30/2015 07:55 AM - Lukas Zapletal

Status: Closed
Priority: High
Assignee: Lukas Zapletal
Category: Orchestration
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3679,
https://github.com/theforeman/foreman_
discovery/pull/292,
https://github.com/theforeman/communit
y-templates/pull/291,
https://github.com/theforeman/foreman/p
ull/3778

Description

Hardware model will be enhanced with two new flags: PXE template specifies
PXE template kind and variant pair to use. Until today, this was hardcoded to
PXELinux or PXEGrub by selected operating system. Optionally, template variant
flag from OS could be simply dropped because PXE template implies variant to
use and there are no variants which share the same configuration syntax (this

is an open item).

Orchestration TFTP code must be modified to use multiple "KIND LOADER default
local boot" and "KIND LOADER global default" templates. Local and global boot
templates must be added for Grub2 new kind. Naming convention will be:

PXELinux BIOS default local boot
PXELinux UEFI default local boot
PXEGrub BIOS default local boot
PXEGrub UEFI default local boot
etc. (the same for global default templates)

But only kind/variant is not enough, users need to select BIOS or UEFI booting
method. This is where Loader flag comes in - selection of three constants:

BIOS, UEFI and SecureBoot UEFI. The first two are obvious causing selection of
the correct DHCP filename when deploying TFTP configuration, the third one
select "shim.efi" chain loading capability for secure booting.

Hardware model fact importing will be enhanced - it will be possible to import
the loader flag from an extra custom fact (defined via global settings).

Related issues:

Related to Foreman - Tracker #431: [TRACKER] UEFI PXE support Resolved
Related to Foreman - Bug #6539: When provisioning a new host, missing templat... Closed
Related to Foreman - Bug #16093: DHCP deletion is scheduled twice on MAC change New
Related to Foreman - Feature #12434: Allow override of filename options in DH... Rejected
Related to Foreman - Bug #16318: PXE templates do not work in safemode Closed
Related to Foreman - Bug #16475: Provisioning fails when proxy is not updated Rejected
Related to Foreman - Bug #16532: Selecting architecture in hostgroup doesn't ... Closed
Related to Foreman - Bug #16819: TFTP Rebuild failed for host Closed
Related to Foreman - Feature #17297: GRUB 2 PXE loader entries for Debian OS ... Closed
Related to Foreman - Bug #17503: Host model load causes unnecessary loads on ... Closed
Related to Foreman - Bug #18381: PXE loader attribute does not work with host... Closed 02/02/2017

Associated revisions

Revision 4cbf879e - 08/24/2016 06:41 AM - Lukas Zapletal
Fixes #12634 - New HW Model flag pxe_loader

Implementation of

https://github.com/theforeman/rfcs/blob/master/text/0001-PXE-Booting-UEFI.md

In short, new host/hostgroup flag PXE loader is added to specify TFTP
DHCP filename and Foreman now orchestrates all PXE-capable templates
deployment (e.g. PXELinux, Grub1, Grub2 if associated to an OS).

Revision cd4c8cdc - 08/24/2016 10:05 AM - Lukas Zapletal
Refs #12634 - added Grub templates for UEFI (#291)

Revision 5df816dc - 08/25/2016 02:59 AM - Dominic Cleal

refs #12634 - remove blank i18n string, match capitalisation

History

#1 - 11/30/2015 07:55 AM - Lukas Zapletal
- Related to Tracker #431: [TRACKER] UEFI PXE support added

#2 - 04/26/2016 03:10 AM - Lukas Zapletal

- Subject changed from Changes in orchestration code to support both PXELinux and Grub2 to Changes in orchestration code to support multiple
kinds

We need to actually support up to three kinds: PXELinux, Grub1, Grub2 for one OS.
#3 - 04/26/2016 04:10 AM - Mathieu Parent

Lukas Zapletal wrote:

We need to actually support up to three kinds: PXELinux, Grub1, Grub2 for one OS.

PXELinux and Grub2 exists as BIOS (Legacy) and UEFI. Is this 5 kinds or 3 kinds x 2 flavors?

#4 - 04/26/2016 06:54 AM - Lukas Zapletal

PXELinux and Grub2 exists as BIOS (Legacy) and UEFI. Is this 5 kinds or 3 kinds x 2 flavors?

The latter, we aim to support both BIOS and EFI systems with either PXELinux and Grub (becaue of RHEL®6 support) or PXELinux and Grub2. The
goal is to deploy PXE files simultaneously so both systems can be booted up.

#5 - 04/26/2016 06:55 AM - Lukas Zapletal

I mean, Foreman will be able to deploy all three at once, but only two of the three will be likely used for one deployment. Grub1 is legacy, the PXE
configuration will be present, but DHCP will hand over usually PXELinux and/or Grub2 on modern systems (RHEL7+).

#6 - 05/04/2016 04:05 AM - Lukas Zapletal

- Subject changed from Changes in orchestration code to support multiple kinds to New host/hostgroup flags pxe_template and loader

Host and hostgroups must be enhanced with two new flags: PXE template specifies PXE template kind and variant pair to use. Until today, this was
hardcoded to PXELinux or PXEGrub by selected operating system. Optionally, template variant flag from OS could be simply dropped because PXE
template implies variant to use and there are no variants which share the same configuration syntax (this is an open item).

But only kind/variant is not enough, users need to select BIOS or UEFI booting method. This is where Loader flag comes in - selection of three
constants: BIOS, UEFI and SecureBoot UEFI. The first two are obvious causing selection of the correct DHCP filename when deploying TFTP
configuration, the third one select "shim.efi" chain loading capability for secure booting.

Similarly to root password, a global setting could be provided for one or both flags for missing values (open item).
#7 - 05/04/2016 04:43 AM - Lukas Zapletal

- Description updated

#8 - 05/04/2016 06:05 AM - Lukas Zapletal

- Description updated

#9 - 05/06/2016 08:48 AM - Mathieu Parent

Lukas Zapletal wrote:

(-]

But only kind/variant is not enough, users need to select BIOS or UEFI| booting method. This is where Loader flag comes in - selection of three
constants: BIOS, UEFI and SecureBoot UEFI. The first two are obvious causing selection of the correct DHCP filename when deploying TFTP
configuration, the third one select "shim.efi" chain loading capability for secure booting.

I'm not sure "booting method" is needed. At least, BIOS or UEFI can be differentiated from DHCP options. See "if option arch" at <
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/6/html/Installation_Guide/s1-netboot-pxe-config-efi.html&gt;.

#10 - 05/13/2016 08:34 AM - Lukas Zapletal

- Related to Bug #6539: When provisioning a new host, missing templates error is not descriptive added

#11 - 05/24/2016 05:53 AM - Lukas Zapletal
- Subject changed from New host/hostgroup flags pxe_template and loader to New HW Model flags pxe_template and loader

- Description updated

#12 - 07/27/2016 11:11 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3679 added

#13 - 08/04/2016 09:16 AM - The Foreman Bot
- Pull request https://github.com/theforeman/community-templates/pull/291 added

#14 - 08/05/2016 06:54 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman_discovery/pull/292 added

#15 - 08/08/2016 10:44 AM - Daniel Lobato Garcia

- Target version setto 1.7.1

#16 - 08/10/2016 07:38 AM - Daniel Lobato Garcia

- Target version changed from 1.7.1 to 117

#17 - 08/10/2016 07:43 AM - Lukas Zapletal
- Status changed from Ready For Testing to Duplicate

- Pull request deleted (https://github.com/theforeman/foreman_discovery/pull/292, https://github.com/theforeman/community-templates/pull/291,
https.//github.com/theforeman/foreman/pull/3679)

This ticket is actually part of #431.

#18 - 08/10/2016 07:47 AM - Lukas Zapletal
- Status changed from Duplicate to Assigned
- Priority changed from Normal to High

- Target version changed from 117 to 1.6.2

- Pull request https://github.com/theforeman/foreman/pull/3679 added

Sorry for the noise, | misassigned the PR to the TRACKER issue.

#19 - 08/10/2016 07:48 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
#20 - 08/10/2016 07:49 AM - Lukas Zapletal
- Subject changed from New HW Model flags pxe_template and loader to New HW Model flag pxe_loader in UI/API

#21 - 08/12/2016 09:40 AM - Lukas Zapletal
- Related to Bug #16093: DHCP deletion is scheduled twice on MAC change added

#22 - 08/15/2016 03:11 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman_discovery/pull/292 added

#23 - 08/16/2016 12:53 PM - The Foreman Bot
- Pull request https://github.com/theforeman/community-templates/pull/291 added

#24 - 08/18/2016 08:14 AM - Lukas Zapletal
- Related to Feature #12434: Allow override of filename options in DHCP host entry added

#25 - 08/22/2016 03:06 PM - Jeff Sparrow
Lukas Zapletal wrote:
We need to actually support up to three kinds: PXELinux, Grub1, Grub2 for one OS.
Would be nice if there was a custom option added to this so people who want to bypass pxelinux, can. We do not use pxelinux, we load undionly (or
whatever we need based on the host, undionly.pxe/kpxe/kkpxe, ipxe.lkrn, etc) and then chain right into iPXE. If | understand correctly, even with this
change we will still end up manually editing foreman source code to suit our needs.
What about a custom option that accepts a string so people can load their own pxe images?
#26 - 08/24/2016 07:02 AM - Lukas Zapletal

- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 4cbf879ed5957978afd74b3707c8a6b16fa18225.

#27 - 08/24/2016 07:16 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#28 - 08/24/2016 09:50 AM - Lukas Zapletal

We currently implemented that as a fixed list with "None" option.

What about a custom option that accepts a string so people can load their own pxe images?

I'd rather see a patch that will allow loading one or more custom entries from foreman.yaml file (name and filename pairs). Free form is little bit
dangerous (e.g. security considerations etc). Feel free to provide a patch, should be easy to do.

#29 - 08/25/2016 02:44 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/3778 added

#30 - 08/26/2016 05:21 AM - Dominic Cleal
- Related to Bug #16318: PXE templates do not work in safemode added

#31 - 09/09/2016 06:44 AM - Dominic Cleal
- Related to Bug #16475: Provisioning fails when proxy is not updated added

#32 - 09/13/2016 09:18 AM - Ivan Necas
- Related to Bug #16532: Selecting architecture in hostgroup doesn't update operating system added

#33 - 10/06/2016 09:24 AM - Dominic Cleal
- Related to Bug #16819: TFTP Rebuild failed for host added
#34 - 11/10/2016 03:31 AM - Dominic Cleal
- Related to Feature #17297: GRUB 2 PXE loader entries for Debian OS family added

#35 - 11/29/2016 04:41 AM - Tomer Brisker

- Related to Bug #17503: Host model load causes unnecessary loads on instantiation added

#36 - 02/02/2017 02:42 PM - Marek Hulan
- Related to Bug #18381: PXE loader attribute does not work with host group inheritance added
